// Copyright (c)2004 Paul Forgey
#ifndef MEEDIO_KRELLMODULE_H
#define MEEDIO_KRELLMODULE_H

#include "../syCommon/DeviceModule.h"

class KrellModule : public DeviceModule
{
public:
    enum {
        // important!  in order of addDevice in initializeModule ()
        kDevice_Showcase  =0,
        kDevice_HTS71     =1
    };
    
    typedef enum {
        kZone_Current,
        kZone_Main,
        kZone_Secondary
    } Zone;

public:
    KrellModule (HANDLE dllInstance, const DeviceCallBackInfo *cbi,
            const std::string &version, const std::string &name);
    virtual ~KrellModule ();

    virtual bool initializeModule (void);
    virtual bool registerProperties (int deviceNumber);

    const char *compression (int) const;
    const char *compressionCode (const char *) const;
    
    const char *device (int, int deviceNumber) const;
    const char *deviceCode (const char *, Zone) const;
    
    const char *directAudio (int, int deviceNumber) const;
    const char *directAudioCode (const char *, Zone) const;
    
    const char *directVideo (int) const;
    const char *directVideoCode (const char *) const;
    
    const char *audioDecode (int) const;
    const char *audioDecodeCode (const char *) const;
    
    const char *buttonCode (const char *) const;
    
    const char *currentAudioDecode (int) const;
    
private:
    static CDevice *createDevice (intptr_t, DEVICE_HANDLE,
            const DeviceModule *, bool isEnabled, const std::string &name,
            const std::string &description);        
};

#endif /* MEEDIO_KRELLMODULE_H */
