// Copyright (c) 2004 Paul Forgey
#ifndef COMMTHREAD_H
#define COMMTHREAD_H

#include <utility>

class CKrellInstance;

class CommThread
{
    private:
        typedef HANDLE arg_type;
        typedef std::pair < CommThread *, arg_type > proc_arg_type;

    private:
        CKrellInstance *m_instance;
        HANDLE m_terminateEvent;
        HANDLE m_thread;
        
    public:
        CommThread (CKrellInstance *);
        virtual ~CommThread ();
        
        // may be called while running to re-start with new commHandle
        bool run (arg_type commHandle);
        void terminate (void);
        
    private:
        unsigned proc (arg_type);
        static unsigned __stdcall threadProc (void *);
};

#endif /* COMMTHREAD_H */
