/*
 * krellstatus.h
 * Copyright (c) 2004 Paul Forgey
 *
 */
#ifndef KRELLSTATUS_H
#define KRELLSTATUS_H

#define kKrellQuery_GetStatus           "GetStatus"
#define kKrellNotification_Status       "Krell Status Update"

enum {
    kKrellStatus1_SystemMute    =0x80,
    kKrellStatus1_MainMute      =0x40,
    kKrellStatus1_Zone2Mute     =0x20,
    kKrellStatus1_Zone2Active   =0x10,
    kKrellStatus1_InTrigger1    =0x08,
    kKrellStatus1_Zone2Only     =0x04,
    kKrellStatus1_Zone2Power    =0x02,
    kKrellStatus1_Power         =0x01,

    kKrellStatus2_MenuMode      =0x80,
    kKrellStatus2_AutoStatus    =0x40,  // will send this every time it changes
    kKrellStatus2_PLLLocked     =0x20,  // valid digital in clocked
    kKrellStatus2_Trigger4      =0x10,
    kKrellStatus2_Trigger3      =0x08,
    kKrellStatus2_Trigger2      =0x04,
    kKrellStatus2_Trigger1      =0x02,
    kKrellStatus2_DSPRunning    =0x01   // not in reset state
};

enum {
    kKrellDevice_DVD    =0,
    kKrellDevice_LD     =1,
    kKrellDevice_SAT    =2,
    kKrellDevice_VCR    =3,
    kKrellDevice_TV     =4,
    kKrellDevice_CD     =5,
    kKrellDevice_TUNER  =6,
    kKrellDevice_AUX1   =7,
    kKrellDevice_GAME   =8,
    kKrellDevice_TAPE   =9
};

enum {
    kKrellVideo_S1      =1,
    kKrellVideo_S2      =2,
    kKrellVideo_S3      =3,
    kKrellVideo_S4      =4,
    kKrellVideo_C1      =5,
    kKrellVideo_C2      =6,
    kKrellVideo_C3      =7,
    kKrellVideo_V1      =8,
    kKrellVideo_V2      =9,
    kKrellVideo_V3      =10,
    kKrellVideo_V4      =11
};

enum {
    kKrellAudio_COAX1   =1,
    kKrellAudio_COAX2   =2,
    kKrellAudio_COAX3   =3,
    kKrellAudio_COAX4   =4,
    kKrellAudio_Opt1    =5,
    kKrellAudio_Opt2    =6,
    kKrellAudio_Opt3    =7,
    kKrellAudio_Opt4    =8,
    kKrellAudio_B1      =9,
    kKrellAudio_S1      =10,
    kKrellAudio_S2      =11,
    kKrellAudio_S3      =12,
    kKrellAudio_S4      =13,
    kKrellAudio_S5      =14,
    kKrellAudio_S6      =15,
    kKrellAudio_S7      =16,
    kKrellAudio_Tape    =17,
    kKrellAudio_VCR     =18,
    kKrellAudio_71      =19
};

enum {
    kKrellSpeaker_Back          = 0x80,
    kKrellSpeaker_Sub           = 0x40,
    kKrellSpeaker_Surround      = 0x20,
    kKrellSpeaker_Center        = 0x10,
    kKrellStream_PCM            = 1,
    kKrellStream_DD20           = 2,
    kKrellStream_DD51           = 3,
    kKrellStream_DTS51          = 4,
    kKrellStream_2496           = 5,
    kKrellStream_PCMDigital     = 6, // how is this different from PCM?
    kKrellStream_PCMAnalog      = 7,
    kKrellStream_DDXY           = 8,
    kKrellSTream_71             = 9,
    kKrellStream_DTSESMatrix    = 10,
    kKrellStream_DTSESDiscrete  = 11,
    kKrellStream_DTSESMatrixDiscrete = 12
};

enum {
    // analog and pcm (2 channel in) decode modes
    kKrellDecode_StereoPass                 =1,
    kKrellDecode_ProLogic2Movie             =2,
    kKrellDecode_ProLogic2Music             =3,
    kKrellDecode_ProLogic2Matrix            =4,
    kKrellDecode_ProLogic2Emulation         =5,
    kKrellDecode_ProLogic2MovieTHX          =6,
    kKrellDecode_71Discrete                 =7,
    kKrellDecode_ProLogic2EmulationTHX      =8,
    kKrellDecode_DTSNeo6Cinema6             =9,
    kKrellDecode_PCM2496                    =10,
    kKrellDecode_DTSNeo6Music               =11,
    kKrellDecode_DTSNeo6CinemaTHX           =12,
    kKrellDecode_Noise                      =13,    // psssssh
    kKrellDecode_Party                      =14,
    kKrellDecode_GeneralAdmission           =15,
    kKrellDecode_FrontRow                   =16,
    kKrellDecode_OnStage                    =17,
    kKrellDecode_EnhancedStereo             =18,
    kKrellDecode_Orchestra                  =19,
    kKrellDecode_Mezzanine                  =20,
    kKrellDecode_FullRangeSub               =21,
    kKrellDecode_Monophonic                 =22,
    kKrellDecode_PreAmp                     =23,    // analog only DSP bypass
    // dolby ac3 2.0 modes
    kKrellDecode_AC3Stereo                  =24,
    kKrellDecode_AC3ProLogic2Movie          =25,
    kKrellDecode_AC3ProLogic2Music          =26,
    kKrellDecode_AC3ProLogic2Matrix         =27,
    kKrellDecode_AC3ProLogic2Emulation      =28,
    kKrellDecode_AC3ProLogic2MovieTHX       =29,
    kKrellDecode_AC3ProLogic2MatrixTHX      =30,
    kKrellDecode_AC3ProLogic2EmulationTHX   =31,
    kKrellDecode_oldDTSNeo6Cinema6          =32,
    kKrellDecode_oldDTSNeo6Cinema5          =33,
    kKrellDecode_oldDTSNeo6Music            =34,
    kKrellDecode_oldDTSNeo6Cinema6THX       =35,
    kKrellDecode_oldDTSNeo6Cinema5THX       =36,
    kKrellDecode_AC3Classical               =37,
    kKrellDecode_AC3GeneralAdmission        =38,
    kKrellDecode_AC3FrontRow                =39,
    kKrellDecode_AC3OnStage                 =40,
    kKrellDecode_AC3EnhancedStereo          =41,
    kKrellDecode_AC3Orchestra               =42,
    kKrellDecode_AC3Mezzanine               =43,
    kKrellDecode_AC3FullRangeSub            =44,
    kKrellDecode_AC3Monophonic              =45,
    kKrellDecode_AC3PreAmp                  =46,    // how is that??
    // dolby ac3 5.1 modes
    kKrellDecode_AC351                      =47,
    kKrellDecode_AC351THX                   =48,
    kKrellDecode_AC351THXEX                 =49,
    // dts modes
    kKrellDecode_DTS51Movie                 =50,
    kKrellDecode_DTS51Matrix                =51,
    kKrellDecode_DTS51MovieTHX              =52,
    kKrellDecode_DTS51Music                 =53,
    kKrellDecode_DTS51MatrixTHX             =54,
    kKrellDecode_DTS61Discrete              =55,
    kKrellDecode_DTS61DiscreteTHX           =56,
    kKrellDecode_DTS51Force                 =57,
    // dolby ac3 x/y modes
    kKrellDecode_AC311                      =65, // 1+1
    kKrellDecode_AC310                      =66, // 1.0
    kKrellDecode_AC330                      =67,
    kKrellDecode_AC321                      =68,
    kKrellDecode_AC331                      =69,
    kKrellDecode_AC322                      =70  // 2.2 ??
};

enum {
    kKrellBalance_Left          =0,
    kKrellBalance_Right         =26,
    kKrellBalance_Mid           =13,
    kKrellBalance_Mask          =0x1f,
    kKrellCompression_Max       =0x20,
    kKrellCompression_Normal    =0x40,
    kKrellCompression_Night     =0x60,
};

enum {
    kKrellTrim_Minimum          =0,
    kKrellTrim_Zero             =10,
    kKrellTrim_Maximum          =20,
    kKrellTrim_Mask             =0x1f
};

enum {
    kKrellLED_Mode1             =0x80,
    kKrellLED_Mode2             =0x00
};

// caller knows a complete structure was read in if start and
// end are both 0x55
typedef struct _KrellStatus
{
    BYTE    start;  // 0x55
    BYTE    status1;
    BYTE    status2;
    BYTE    device;
    BYTE    volume;
    BYTE    zone2Volume;
    BYTE    videoInput;
    BYTE    audioInput;
    BYTE    zone2Input;
    BYTE    stream;
    BYTE    decode;
    BYTE    balance;
    BYTE    eq;             // 0: off, 1-4
    BYTE    centerTrim;
    BYTE    surroundTrim;   // also carries kKrellLED_
    BYTE    backTrim;
    BYTE    subTrim;
    BYTE    end;    // 0x55
} KrellStatus;

#endif /* KRELLSTATUS_H */
